import { curry } from '@typed/lambda';
import { chain } from './chain';
import { map } from './map';
/**
 * Apply the function in a tuple to the values in another using the second value.
 * @param fn :: Tuple a (b -> Tuple a c)
 * @param tuple :: Tuple a b
 * @returns Tuple a c
 */
export const ap = curry((fn, value) => chain((f) => map(f, value), fn));
//# sourceMappingURL=ap.js.map