import { curry } from '@typed/lambda';
import { chainLeft } from './chainLeft';
import { mapLeft } from './mapLeft';
/**
 * Apply the function in a tuple to the values in another using the left value.
 * @param fn :: Tuple (a -> Tuple a c) b
 * @param tuple :: Tuple a b
 * @returns Tuple a c
 */
export const apLeft = curry((fn, tuple) => chainLeft((f) => mapLeft(f, tuple), fn));
//# sourceMappingURL=apLeft.js.map