import { curry } from '@typed/lambda';
import { second } from './tuple';
/**
 * Chain together tuples using the `second` value of a given tuple.
 * @param fn :: (b -> Tuple a c)
 * @param tuple :: Tuple a b
 * @returns Tuple a c
 */
export const chain = curry((fn, tuple) => fn(second(tuple)));
//# sourceMappingURL=chain.js.map