import { curry } from '@typed/lambda';
import { first } from './tuple';
/**
 * Chain together tuples using the `first` value of a given tuple.
 * @param fn :: (a -> Tuple a c)
 * @param tuple :: Tuple a b
 * @returns Tuple a c
 */
export const chainLeft = curry((fn, tuple) => fn(first(tuple)));
//# sourceMappingURL=chainLeft.js.map