import { curry } from '@typed/lambda';
import { first, second } from './tuple';
/**
 * Map the second value of a tuple
 * @param fn:: (b -> c)
 * @param tuple :: Tuple a b
 * @returns :: Tuple a c
 */
export const map = curry((fn, tuple) => [first(tuple), fn(second(tuple))]);
//# sourceMappingURL=map.js.map